<template>
  <div class="time-line block">
    <p class="title is-4">Timeline</p>
    <p class="subtitle is-4">Who talked when?</p>
    <svg class="time-line-chart"></svg>
    <section>
      Red cards are raised when someone has interrupted the previous speaker.
    </section>
  </div>
</template>

<script>
import * as d3 from 'd3';
import * as _ from 'lodash';
import { mapState } from 'vuex';
import d3Configuration from '@/components/d3-configuration';
import { talkerScale } from '@/components/commons';

export default {
  name: 'time-line',
  computed: {
    ...mapState({
      meeting: 'meeting',
    }),
  },
  watch: {
    meeting() {
      this.render();
    },
  },
  mounted() {
    this.render();
  },
  created() {
    this.$store.subscribe((mutation, state) => {
      if (mutation.type === 'setTalkerGender') {
        this.render();
      }
    });
  },
  methods: {
    render() {
      const { talkers, interventions } = this.meeting;
      const maxDuration = this.meeting.duration;

      const x = d3.scaleLinear()
        .domain([0, maxDuration])
        .range([0, d3Configuration.widthTotal - d3Configuration.widthName]);

      const yPos = talkerScale(
        _.values(talkers),
        d3Configuration.heightLine * _.size(talkers),
      );

      const chart = d3.select('.time-line-chart')
        .attr('width', d3Configuration.widthTotal)
        .attr('height', d3Configuration.heightLine * _.size(talkers));

      chart.selectAll('g')
        .remove();

      const blockLines = chart
        .append('g')
        .attr('transform', `translate(${d3Configuration.widthName},0)`);

      const lineBlock = blockLines
        .selectAll('line')
        .remove()
        .data(interventions);

      lineBlock.enter()
        .append('line')
        .classed('intervention', true)
        .attr('x1', (interv) => x(interv.timeStart))
        .attr('x2', (interv) => x(interv.timeEnd))
        .attr('y1', (interv) => yPos(interv.talker))
        .attr('y2', (interv) => yPos(interv.talker))
        .attr('class', (interv) => `gender-${this.meeting.getTalkerGender(interv.talker)}`);

      lineBlock.exit().remove();

      const interrupterCards = blockLines
        .selectAll('rect.interrupting')
        .remove()
        .data(interventions.filter((i) => i.isInterrupting));

      interrupterCards.enter()
        .append('rect')
        .classed('interrupting', true)
        .attr('x', (interv) => x(interv.timeStart) - 1)
        .attr('y', (interv) => yPos(interv.talker) - d3Configuration.heightLine / 2.5)
        .attr('width', 3)
        .attr('height', d3Configuration.heightLine / 3);

      chart.selectAll('text')
        .remove();
      const nameBlock = chart.selectAll('text')
        .data(_.values(talkers), (d) => d.name);

      nameBlock.enter()
        .append('text')
        .attr('x', d3Configuration.widthName)
        .attr('y', (talker) => yPos(talker.name))
        .attr('dx', '-0.5em')
        .attr('text-anchor', 'end')
        .text((d) => `${d.name}`);

      nameBlock.exit().remove();
    },
  },
};
</script>
<style>

.time-line-chart text {
  fill: darkgray;
  font: 15px sans-serif;
  text-anchor: end;
  dominant-baseline: central;
}

.time-line-chart line {
  stroke-width: 18;
}

.time-line-chart rect.interrupting {
  fill: red;
}

/* .chart div {
  font: 10px sans-serif;
  background-color: steelblue;
  text-align: right;
  padding: 3px;
  margin: 1px;
  color: white;
} */
</style>
